# Expression Class Reference
[Logical expressions used in OSQL and Form]

Factory for various childs of LogicalObjects. More...

Inheritance diagram for Expression:
[legend]

List of all members.

## Static Public Member Functions

static | expAnd ($left, $right)
static | expOr ($left, $right)
static | eq ($field, $value)
static | eqId ($field, Identifiable $object)
static | notEq ($field, $value)
static | gt ($field, $value)
| greater than
static | gtEq ($field, $value)
| greater than or equals
static | lt ($field, $value)
| lower than
static | ltEq ($field, $value)
| lower than or equals
static | notNull ($field)
static | isNull ($field)
static | isTrue ($field)
static | isFalse ($field)
static | like ($field, $value)
static | notLike ($field, $value)
static | ilike ($field, $value)
static | notIlike ($field, $value)
static | similar ($field, $value)
static | notSimilar ($field, $value)
static | eqLower ($field, $value)
static | between ($field, $left, $right)
static | in ($field, $value)
| {,not}in handles strings, arrays and SelectQueries
static | notIn ($field, $value)
static | add ($field, $value)
| +
static | sub ($field, $value)

static | mul ($field, $value)
| *
static | div ($field, $value)
| /
static | mod ($field, $value)
| %
static | fullTextAnd ($field, $wordsList)
static | fullTextOr ($field, $wordsList)
static | fullTextRankOr ($field, $wordsList)
static | fullTextRankAnd ($field, $wordsList)
static | orBlock ()
static | andBlock ()
static | chain ()
static | not ($field)
static | minus ($field)

## Static Private Member Functions

static | block ($args, $logic)

## Detailed Description

Factory for various childs of LogicalObjects.

Definition at line 17 of file Expression.class.php.

## Member Function Documentation

static Expression::add | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

+

Returns:
  BinaryExpression

Definition at line 248 of file Expression.class.php.

References BinaryExpression::ADD.

Referenced by DaoUtils::increment(), and TimeIntervalsGenerator::toSelectQuery().

static Expression::andBlock | ( |  | ) | `[static]`

Returns:
  LogicalChain

Definition at line 339 of file Expression.class.php.

References block(), and BinaryExpression::EXPRESSION_AND.

Referenced by Criteria::__construct(), LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

Here is the call graph for this function:

static Expression::between | ( | $ | field,
|  | $ | left,
|  | $ | right |
| ) |  |  | `[static]`

Returns:
  LogicalBetween

Definition at line 204 of file Expression.class.php.

Referenced by LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

static Expression::block | ( | $ | args,
|  | $ | logic |
| ) |  |  | `[static, private]`

Returns:
  LogicalChain

Definition at line 374 of file Expression.class.php.

References $args.

Referenced by andBlock(), and orBlock().

static Expression::chain | ( |  | ) | `[static]`

Returns:
  LogicalChain

Definition at line 350 of file Expression.class.php.

Referenced by OqlSelectQuery::toCriteria().

static Expression::div | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

/

Returns:
  BinaryExpression

Definition at line 278 of file Expression.class.php.

References BinaryExpression::DIVIDE.

static Expression::eq | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 42 of file Expression.class.php.

References BinaryExpression::EQUALS.

Referenced by MetaConfiguration::checkEnumerationReferentialIntegrity(), BaseDaoWorker::dropById(), UnifiedContainerWorker::dropList(), eqId(), CommonDaoWorker::getById(), in(), ManyToManyLinkedWorker::joinHelperTable(), Criteria::joinProperties(), ManyToManyLinkedWorker::makeDeleteQuery(), ProtoDAO::processPath(), and OneToManyLinkedFull::sync().

static Expression::eqId | ( | $ | field,
|  | Identifiable $ | object |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 50 of file Expression.class.php.

References eq(), and Identifiable::getId().

Referenced by DaoUtils::increment(), OneToManyLinkedWorker::targetize(), and StorableDAO::targetizeUpdateQuery().

Here is the call graph for this function:

static Expression::eqLower | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  EqualsLowerExpression

Definition at line 196 of file Expression.class.php.

static Expression::expAnd | ( | $ | left,
|  | $ | right |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 22 of file Expression.class.php.

References BinaryExpression::EXPRESSION_AND.

static Expression::expOr | ( | $ | left,
|  | $ | right |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 32 of file Expression.class.php.

References BinaryExpression::EXPRESSION_OR.

Referenced by LogicUtils::getOpenRange().

static Expression::fullTextAnd | ( | $ | field,
|  | $ | wordsList |
| ) |  |  | `[static]`

Returns:
  FullTextSearch

Definition at line 296 of file Expression.class.php.

References DB::FULL_TEXT_AND.

static Expression::fullTextOr | ( | $ | field,
|  | $ | wordsList |
| ) |  |  | `[static]`

Returns:
  FullTextSearch

Definition at line 304 of file Expression.class.php.

References DB::FULL_TEXT_OR.

Referenced by FullTextUtils::makeFullTextQuery().

static Expression::fullTextRankAnd | ( | $ | field,
|  | $ | wordsList |
| ) |  |  | `[static]`

Returns:
  FullTextRank

Definition at line 320 of file Expression.class.php.

References DB::FULL_TEXT_AND.

Referenced by FullTextUtils::makeFullTextQuery().

static Expression::fullTextRankOr | ( | $ | field,
|  | $ | wordsList |
| ) |  |  | `[static]`

Returns:
  FullTextRank

Definition at line 312 of file Expression.class.php.

References DB::FULL_TEXT_OR.

static Expression::gt | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

greater than

Returns:
  BinaryExpression

Definition at line 70 of file Expression.class.php.

References BinaryExpression::GREATER_THAN.

Referenced by DaoMoveHelper::down(), and DaoIterator::loadNextChunk().

static Expression::gtEq | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

greater than or equals

Returns:
  BinaryExpression

Definition at line 82 of file Expression.class.php.

References BinaryExpression::GREATER_OR_EQUALS.

static Expression::ilike | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 164 of file Expression.class.php.

References BinaryExpression::ILIKE.

static Expression::in | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

{,not}in handles strings, arrays and SelectQueries

Returns:
  LogicalObject

Definition at line 214 of file Expression.class.php.

References eq(), and InExpression::IN.

Referenced by BaseDaoWorker::dropByIds(), OqlInExpression::evaluate(), ProtoDAO::fetchCollections(), NullDaoWorker::getListByIds(), CommonDaoWorker::getListByIds(), ManyToManyLinkedWorker::makeDeleteQuery(), OneToManyLinkedLazy::makeMassUpdateQuery(), OneToManyLinkedLazy::sync(), and OneToManyLinkedFull::sync().

Here is the call graph for this function:

static Expression::isFalse | ( | $ | field | ) | `[static]`

Returns:
  PostfixUnaryExpression

Definition at line 140 of file Expression.class.php.

References PostfixUnaryExpression::IS_FALSE.

static Expression::isNull | ( | $ | field | ) | `[static]`

Returns:
  PostfixUnaryExpression

Definition at line 124 of file Expression.class.php.

References PostfixUnaryExpression::IS_NULL.

Referenced by LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

static Expression::isTrue | ( | $ | field | ) | `[static]`

Returns:
  PostfixUnaryExpression

Definition at line 132 of file Expression.class.php.

References PostfixUnaryExpression::IS_TRUE.

static Expression::like | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 148 of file Expression.class.php.

References BinaryExpression::LIKE.

static Expression::lt | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

lower than

Returns:
  BinaryExpression

Definition at line 94 of file Expression.class.php.

References BinaryExpression::LOWER_THAN.

Referenced by DaoMoveHelper::up().

static Expression::ltEq | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

lower than or equals

Returns:
  BinaryExpression

Definition at line 106 of file Expression.class.php.

References BinaryExpression::LOWER_OR_EQUALS.

Referenced by LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

static Expression::minus | ( | $ | field | ) | `[static]`

Returns:
  PrefixUnaryExpression

Definition at line 366 of file Expression.class.php.

References PrefixUnaryExpression::MINUS.

static Expression::mod | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

%

Returns:
  BinaryExpression

Definition at line 288 of file Expression.class.php.

References BinaryExpression::MOD.

static Expression::mul | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

*

Returns:
  BinaryExpression

Definition at line 268 of file Expression.class.php.

References BinaryExpression::MULTIPLY.

Referenced by TimeIntervalsGenerator::toSelectQuery().

static Expression::not | ( | $ | field | ) | `[static]`

Returns:
  PrefixUnaryExpression

Definition at line 358 of file Expression.class.php.

References PrefixUnaryExpression::NOT.

static Expression::notEq | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 58 of file Expression.class.php.

References BinaryExpression::NOT_EQUALS.

Referenced by notIn().

static Expression::notIlike | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 172 of file Expression.class.php.

References BinaryExpression::NOT_ILIKE.

static Expression::notIn | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  LogicalObject

Definition at line 230 of file Expression.class.php.

References InExpression::NOT_IN, and notEq().

Referenced by OqlInExpression::evaluate().

Here is the call graph for this function:

static Expression::notLike | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 156 of file Expression.class.php.

References BinaryExpression::NOT_LIKE.

static Expression::notNull | ( | $ | field | ) | `[static]`

Returns:
  PostfixUnaryExpression

Definition at line 116 of file Expression.class.php.

References PostfixUnaryExpression::IS_NOT_NULL.

Referenced by ProtoDAO::fetchCollections(), LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

static Expression::notSimilar | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 188 of file Expression.class.php.

References BinaryExpression::NOT_SIMILAR_TO.

static Expression::orBlock | ( |  | ) | `[static]`

Returns:
  LogicalChain

Definition at line 328 of file Expression.class.php.

References block(), and BinaryExpression::EXPRESSION_OR.

Referenced by LogicUtils::getOpenPoint(), and LogicUtils::getOpenRange().

Here is the call graph for this function:

static Expression::similar | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 180 of file Expression.class.php.

References BinaryExpression::SIMILAR_TO.

static Expression::sub | ( | $ | field,
|  | $ | value |
| ) |  |  | `[static]`

Returns:
  BinaryExpression

Definition at line 258 of file Expression.class.php.

References BinaryExpression::SUBSTRACT.

The documentation for this class was generated from the following file:

- core/Logic/Expression.class.php